import numpy
import cPickle
import scipy.io

from os import listdir
from os.path import isfile, join
from sklearn.metrics import f1_score

mypath = './res/'

onlyfiles = [f for f in listdir(mypath) if isfile(join(mypath, f))]

mat = cPickle.load(open('../dataset/bioinformatics_data.p'))

ensemble_ppred = None
count = 0
res_dic = {}
macro_f1 = {}
micro_f1 = {}

for file in onlyfiles:
    try:
        pred, ppred = cPickle.load(open(join(mypath, file), 'rb'))
        if count == 0:
            ensemble_ppred = ppred
        else:
            ensemble_ppred += ppred
        count += 1
        ensemble_pred = numpy.argmax(ensemble_ppred, axis=1)

        accuracy = 1 - numpy.mean(numpy.not_equal(ensemble_pred, mat['testY'].ravel()-1))
        macro_f1[count] = f1_score(mat['testY'].ravel()-1, ensemble_pred, average='macro')
        micro_f1[count] = f1_score(mat['testY'].ravel()-1, ensemble_pred, average='micro')

        res_dic[count] = accuracy
    except:
        print file

print res_dic
print macro_f1
print micro_f1
